/**
 *  txt.ivp
 */
#pragma once

#include <winsdkver.h>
#if _WIN32_WINNT_MAXVER < 0x0A00
#define _WIN32_WINNT  0x0501
#else
#define _WIN32_WINNT  0x0A00
#endif
#define  WIN32_LEAN_AND_MEAN

#include <windows.h>

#ifdef NDEBUG

#ifdef RtlMoveMemory
#undef RtlMoveMemory
EXTERN_C NTSYSAPI VOID NTAPI RtlMoveMemory(LPVOID UNALIGNED, LPCVOID UNALIGNED, SIZE_T);
#endif

#ifdef RtlZeroMemory
#undef RtlZeroMemory
EXTERN_C NTSYSAPI VOID NTAPI RtlZeroMemory(LPVOID UNALIGNED, SIZE_T);
#endif

#pragma warning(push)
#pragma warning(disable: 4595)

inline void * operator new (size_t cb)
{
	return ::HeapAlloc(::GetProcessHeap(), 0, cb);
}
inline void * operator new[] (size_t cb)
{
	return ::HeapAlloc(::GetProcessHeap(), 0, cb);
}

inline void operator delete (void *pv)
{
	::HeapFree(::GetProcessHeap(), 0, pv);
}
inline void operator delete[] (void *pv)
{
	::HeapFree(::GetProcessHeap(), 0, pv);
}
inline void operator delete (void *pv, size_t)
{
	::HeapFree(::GetProcessHeap(), 0, pv);
}

#pragma warning(pop)

#endif//NDEBUG
